// Copyright 2003 Leigh L. Klotz, Jr.

package com.hipme.flipper;

import danger.app.Application;
import danger.app.AppResources;
import danger.app.DataStore;
import danger.app.Listener;
import danger.app.Registrar;
import danger.app.SettingsDB;
import danger.app.IPCMessage;
import danger.app.Event;
import danger.app.EventType;
import danger.app.SettingsDB;
import danger.app.SettingsDBException;
import danger.net.HiptopConnection;
import danger.net.HiptopTransaction;
import danger.ui.Bitmap;
import danger.ui.CheckBox;
import danger.ui.DialogWindow;
import danger.ui.View;
import danger.ui.Pen;
import danger.ui.StaticText;
import danger.ui.Style;
import danger.util.DEBUG;
import java.util.Vector;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

/**
 * The Message class
 */
class Message extends Listener implements Resources, Constants, Events {
  String userName;
  String text;

  Message() {
  }

  Message(String userName) {
    this.userName = userName;
  }

  void handleReceiveNewMessage(String text) {    
    flipper app = (flipper)Application.getCurrentApp();
    app.setWho(userName);
    this.text = text;
    app.notifyAlert(userName, getNotice());
    app.flipWindow.flipIn(userName, text);
    app.pendingQueue.dequeue();
    app.updatePreviewScreen();
  }

  String getNotice() {
    return userName + " has flipped you: " + text;
  }

  // needs to be in the prefs or datastore
  static int seqNo = 0;

  public boolean flipOut(byte what, String message) {
    return flipOut(what, message.getBytes());
  }

  public boolean flipOut(byte what, byte []message) {
    HiptopConnection htc = new HiptopConnection();
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    baos.write(what);
    byte[] nameBytes = htc.getUserName().getBytes();
    try {
      baos.write(nameBytes.length);
      baos.write(nameBytes);
      baos.write(message);
      baos.close();
    } catch (IOException ioe) {
      ioe.printStackTrace();
      throw new RuntimeException(ioe.getMessage());
    }
    byte[] totalMessage = baos.toByteArray();
    htc.send(userName, totalMessage, seqNo++);
    DEBUG.p("Message sent: userName="+ userName+" type=" + what+" length="+totalMessage.length);
    return true;
  }

}
