// Copyright (c) 2003, 2004 Leigh L. Klotz, Jr. <klotz@graflex.org>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

package com.hipme.flipper;

import danger.app.Application;
import danger.app.Listener;
import danger.app.Event;
import danger.ui.View;
import danger.ui.TypeAheadTextField;
import danger.util.TextFinder;
import danger.ui.ListSelectMenu;
import danger.util.DEBUG;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import danger.ui.MenuItem;


public class FriendTextField extends TypeAheadTextField {
  // If we don't set the listener to null, then events go around and around
  // and we get multiple RETURNs in forms, and in the simulator, if you
  // press WHEEL it goes into an infinite loop.
  public void setListener(danger.ui.View view) {
    super.setListener(null);
  }
  public FriendTextField() {
    super(new FriendTextFinder());
  }
}

class FriendTextFinder extends Listener implements TextFinder {
  public final void search(ListSelectMenu menu, String inKey) {
    if (inKey.length() > 0) {
      Hashtable friends = Friends.getFriends();
      Vector v = new Vector();
      Enumeration e = friends.keys();
      while (e.hasMoreElements()) {
	String name = (String)(e.nextElement());
	if (name.startsWith(inKey)) {
	  v.addElement(new MenuItem(name));
	}
      }
      menu.updateMenuContents(v);
    } else {
      menu.updateMenuContents(new MenuItem[0]);
    }
  }
}
