// Copyright (c) 2003, 2004 Leigh L. Klotz, Jr. <klotz@graflex.org>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


package com.hipme.flipper;

import danger.app.Application;
import danger.app.AppResources;
import danger.app.DataStore;
import danger.app.Listener;
import danger.app.Registrar;
import danger.app.SettingsDB;
import danger.app.IPCMessage;
import danger.app.Event;
import danger.app.EventType;
import danger.app.SettingsDB;
import danger.app.SettingsDBException;
import danger.net.HiptopConnection;
import danger.net.HiptopTransaction;
import danger.ui.Bitmap;
import danger.ui.CheckBox;
import danger.ui.DialogWindow;
import danger.ui.View;
import danger.ui.Pen;
import danger.ui.StaticText;
import danger.ui.Style;
import danger.util.DEBUG;
import java.util.Vector;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

/**
 * The Message class
 */
class Message extends Listener implements Resources, Constants, Events {
  String userName;
  String text;

  Message() {
  }

  Message(String userName) {
    this.userName = userName;
  }

  void handleReceiveNewMessage(String text) {    
    flipper app = (flipper)Application.getCurrentApp();
    app.setWho(userName);
    this.text = text;
    Friend friend = Friends.getFriend(userName);
//    if (text.equals("WRU") && Registrar.serviceExists("location") && friend.getProvideLocation()) {
//      IPCMessage ipc = new IPCMessage();
//      ipc.addItem("action" , "location");
//      ipc.addItem("userName", userName);
//      Registrar.sendMessage("location" , ipc, new Event(this, kLocationResult));
//      DEBUG.p("flipper: sent WRU to " + userName);
//    } else {
//      app.notifyAlert(userName, getNotice());
//      app.flipWindow.flipIn(userName, text);
//    }
    app.pendingQueue.dequeue();
    app.updatePreviewScreen();
  }

//  public boolean receiveEvent(Event event) {
//    boolean consumed = true;
//    switch (event.type) {
//    case kLocationResult:
//      {
//	IPCMessage ipcmessage = (IPCMessage)event.argument;
//	String userName = ipcmessage.findString("userName");
//	String location = ipcmessage.findString("location");
//	DEBUG.p("flipper: receive WRU response: " + location);
//	flipOut(WHAT_MESSAGE, location);
//	break;
//      }
//    default:
//      consumed = false;
//    }
//    return consumed;
//  }
//
  String getNotice() {
    return userName + " has flipped you: " + text;
  }

  // needs to be in the prefs or datastore
  static int seqNo = 0;

  public boolean flipOut(byte what, String message) {
    return flipOut(what, message.getBytes());
  }

  public boolean flipOut(byte what, byte []message) {
    HiptopConnection htc = new HiptopConnection();
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    baos.write(what);
    byte[] nameBytes = htc.getUserName().getBytes();
    try {
      baos.write(nameBytes.length);
      baos.write(nameBytes);
      baos.write(message);
      baos.close();
    } catch (IOException ioe) {
      ioe.printStackTrace();
      throw new RuntimeException(ioe.getMessage());
    }
    byte[] totalMessage = baos.toByteArray();
    htc.send(userName, totalMessage, seqNo++);
    DEBUG.p("Message sent: userName="+ userName+" type=" + what+" length="+totalMessage.length);
    return true;
  }

}
